【剑斩OFFER】算法的暴力美学——颜色分类

一、题目描述

二、算法原理

由题目可知,我们可以把一个数组(无论是什么数组最终的情况)里面的情况分成:

故而,我们可以使用分治的思想来解决这道题:

可以把这个数组分成四个部分:

【0,left】:等于0

【left+1,i -1】:等于1

【i,right - 1】:未知数字(待扫描)

【right,nums.size() -1】:等于2

根据上面这四个部分可以制定处理方法:

当 nums i == 0 时,swap(nums i++ ,nums ++left );

当 nums i == 1 时,i++

当 nums i == 2 时,swap(nums i ,nums -- right ),注意:这里的 i 是不能 ++ 的,因为当他们交换时,nums i 是一个未扫描的数字,所以我们要再扫描一次。

当然一开始 left = -1,i = 0,right = nums.size(),因为我们还没有开始处理数据。

三、代码实现

cpp 复制代码
class Solution {
public:
    void sortColors(vector<int>& nums) {
        int i = 0;
        int left = -1,right = nums.size();
        while(i < right)
        {
            if(nums[i] == 0) swap(nums[i],nums[++left]);
            else if(nums[i] == 2)
            {
                swap(nums[i],nums[--right]);
                continue;//再次扫描未知数据
            }
            i++;
        }
    }
};
相关推荐
apcipot_rain7 小时前
C++转Java日记(04)
java·开发语言·c++
NEFU_Jyj8 小时前
牛客周赛R168
算法
WL学习笔记10 小时前
vector模拟实现
c++
蜗牛一步步往上爬12 小时前
第十六章 C++语言在深度学习中的应用
开发语言·c++·深度学习
likexuec14 小时前
数据结构(2)
数据结构
Navigator_Z15 小时前
LeetCode //C - 1317. Convert Integer to the Sum of Two No-Zero Integers
c语言·算法·leetcode
wo_jack16 小时前
C++ 入门笔记(十六):第16课 vector 模拟实现十问十答 —— 从三指针到迭代器失效
c++·后端·面试·stl·vector
D e re k ZH16 小时前
C++ 标准库算法全景指南
数据结构·c++·算法
冻柠檬飞冰走茶17 小时前
字母移动游戏题解:贪心求最长可保留连续子串(附 C 实现)
c语言·开发语言·数据结构·算法·动态规划